/* 
 *  GGI/DM default visual library
 *
 *  Copyright (c) 1999 Nicolai Haehnle - Locinga@pfaffenwinkel.de
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#define DEBUG		1

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#include <string.h>

#include <ggi/internal/ggi-dl.h>
#include <ggi/internal/dm_int.h>
#include "default.h"

int GGIdlinit(ggi_visual *vis,const char *args,void *argptr)
{
	dmext *hook=LIBGGI_DMEXT(vis);
	
	GGIDPRINT("initializing display-default-dm(%s) on %p\n", args, vis);

	hook->setmode 	   = GGIDMsetmode;
	hook->adddrawmap   = GGIDMadddrawmap;
	hook->flip 	   = GGIDMflip;
	hook->closedrawmap = GGIDMclosedrawmap;
	hook->acquire      = GGIDMacquire;
	hook->getvisual	   = GGIDMgetvisual;
	
	if (vis->opdisplay->setflags != GGIDMsetflags) {
		hook->old_setflags = vis->opdisplay->setflags;
		vis->opdisplay->setflags = GGIDMsetflags;
	}
	if (vis->opdisplay->flush != GGIDMflush) {
		hook->old_flush	   = vis->opdisplay->flush;
		vis->opdisplay->flush	 = GGIDMflush;
	}
	if (vis->opcolor->setpalvec != GGIDMsetpalvec) {
		hook->old_setpalvec	= vis->opcolor->setpalvec;
		vis->opcolor->setpalvec = GGIDMsetpalvec;
	}

	return GGI_DL_EXTENSION;
}


int GGIdlcleanup(ggi_visual *vis)
{
	return 0;
}

#include <ggi/internal/ggidlinit.h>
